; 
.nolist
    include \masm32\include\masm32rt.inc
    .586    
    .xmm        
    include \masm32\macros\timers.asm
    include IdCPU.asm
.listall
comment *Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros - AMD *
.code
option prologue:none  ; turn it off
option epilogue:none  ;
align  16             ; 
bin2ascii proc lpbuf:DWORD, nNumber:DWORD
    push edi                ; Save as per calling conventions.
    push ebx                ; Save as per calling conventions.
    mov  edi, [esp+12]      ; sptr
    mov  eax, [esp+16]      ; x
    mov  ecx, eax           ; Save original argument.
    mov  edx, 89705F41h     ; 1e-9 * 2^61 rounded
    mul  edx                ; Divide by 1e9 by multiplying with reciprocal.
    add  eax, eax           ; Round division result.
    adc  edx, 0             ; EDX[31-29] = argument / 1e9
    shr  edx, 29            ; Leading decimal digit, 0...4
    mov  eax, edx           ; Leading digit
    mov  ebx, edx           ; Initialize digit accumulator with
    imul eax, 1000000000    ; Leading digit * 1e9
    sub  ecx, eax           ; Subtract (leading digit * 1e9) from argument.
    or   dl, '0'            ; Convert leading digit to ASCII.
    mov  [edi], dl          ; Store leading digit.
    cmp  ebx, 1             ; Any nonzero digit yet?
    sbb  edi, -1            ; Yes, increment ptr. No, keep old ptr.
    mov  eax, ecx           ; Get reduced argument < 1e9.
    mov  edx, 0abcc7712h    ; 2^28 / 1e8 * 2^30 rounded up
    mul  edx                ; Divide reduced
    shr  eax, 30            ;  argument < 1e9 by 1e8,
    lea  edx, [eax+4*edx+1] ;  converting it into 4.28 fixed-point
    mov  eax, edx           ;  format such that 1.0 = 2^28.
    shr  eax, 28            ; Next digit
    and  edx, 0fffffffh     ; Fraction part
    or   ebx, eax           ; Accumulate next digit.
    or   eax, '0'           ; Convert digit to ASCII.
    mov  [edi], al          ; Store digit in memory.
    lea  eax, [edx*4+edx]   ; 5 * fraction, new digit EAX[31-27]
    lea  edx, [edx*4+edx]   ; 5 * fraction, new fraction EDX[26-0]
    cmp  ebx, 1             ; Any nonzero digit yet?
    sbb  edi, -1            ; Yes, increment ptr. No, keep old ptr.
    shr  eax, 27            ; Next digit
    and  edx, 07ffffffh     ; Fraction part
    or   ebx, eax           ; Accumulate next digit.
    or   eax, '0'           ; Convert digit to ASCII.
    mov  [edi], al          ; Store digit in memory.
    lea  eax, [edx*4+edx]   ; 5 * fraction, new digit EAX[31-26]
    lea  edx, [edx*4+edx]   ; 5 * fraction, new fraction EDX[25-0]
    cmp  ebx, 1             ; Any nonzero digit yet?
    sbb  edi, -1            ; Yes, increment ptr. No, keep old ptr.
    shr  eax, 26            ; Next digit
    and  edx, 03ffffffh     ; Fraction part
    or   ebx, eax           ; Accumulate next digit.
    or   eax, '0'           ; Convert digit to ASCII.
    mov  [edi], al          ; Store digit in memory.
    lea  eax, [edx*4+edx]   ; 5 * fraction, new digit EAX[31-25]
    lea  edx, [edx*4+edx]   ; 5 * fraction, new fraction EDX[24-0]
    cmp  ebx, 1             ; Any nonzero digit yet?
    sbb  edi, -1            ; Yes, increment ptr. No, keep old ptr.
    shr  eax, 25            ; Next digit
    and  edx, 01ffffffh     ; Fraction part
    or   ebx, eax           ; Accumulate next digit.
    or   eax, '0'           ; Convert digit to ASCII.
    mov  [edi], al          ; Store digit in memory.
    lea  eax, [edx*4+edx]   ; 5 * fraction, new digit EAX[31-24]
    lea  edx, [edx*4+edx]   ; 5 * fraction, new fraction EDX[23-0]
    cmp  ebx, 1             ; Any nonzero digit yet?
    sbb  edi, -1            ; Yes, increment ptr, No, keep old ptr.
    shr  eax, 24            ; Next digit
    and  edx, 00ffffffh     ; Fraction part
    or   ebx, eax           ; Accumulate next digit.
    or   eax, '0'           ; Convert digit to ASCII.
    mov  [edi], al          ; Store digit in memory.
    lea  eax, [edx*4+edx]   ; 5 * fraction, new digit EAX[31-23]
    lea  edx, [edx*4+edx]   ; 5 * fraction, new fraction EDX[31-23]
    cmp  ebx, 1             ; Any nonzero digit yet?
    sbb  edi, -1            ; Yes, increment ptr. No, keep old ptr.
    shr  eax, 23            ; Next digit
    and  edx, 007fffffh     ; Fraction part
    or   ebx, eax           ; Accumulate next digit.
    or   eax, '0'           ; Convert digit to ASCII.
    mov  [edi], al          ; Store digit out to memory.
    lea  eax, [edx*4+edx]   ; 5 * fraction, new digit EAX[31-22]
    lea  edx, [edx*4+edx]   ; 5 * fraction, new fraction EDX[22-0]
    cmp  ebx, 1             ; Any nonzero digit yet?
    sbb  edi, -1            ; Yes, increment ptr. No, keep old ptr.
    shr  eax, 22            ; Next digit
    and  edx, 003fffffh     ; Fraction part
    or   ebx, eax           ; Accumulate next digit.   
    or   eax, '0'           ; Convert digit to ASCII.
    mov  [edi], al          ; Store digit in memory.
    lea  eax, [edx*4+edx]   ; 5 * fraction, new digit EAX[31-21]
    lea  edx, [edx*4+edx]   ; 5 * fraction, new fraction EDX[21-0]
    cmp  ebx, 1             ; Any nonzero digit yet?
    sbb  edi, -1            ; Yes, increment ptr. No, keep old ptr.
    shr  eax, 21            ; Next digit
    and  edx, 001fffffh     ; Fraction part
    or   ebx, eax           ; Accumulate next digit.
    or   eax, '0'           ; Convert digit to ASCII.
    mov  [edi], al          ; Store digit in memory.
    lea  eax, [edx*4+edx]   ; 5 * fraction, new digit EAX[31-20]
    cmp  ebx, 1             ; Any nonzero digit yet?
    sbb  edi, -1            ; Yes, increment ptr. No, keep old ptr.
    shr  eax, 20            ; Next digit
    or   eax, '0'           ; Convert digit to ASCII.
    mov  [edi], ax          ; Store last digit and end marker in memory.
    pop  ebx                ; Restore register as per calling convention.
    pop  edi                ; Restore register as per calling convention.
    ret  8                  ; Pop two DWORD arguments and return.
bin2ascii endp        ;
option prologue:prologuedef ; turn back on the defaults
option epilogue:epiloguedef ;    

; 
comment *Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros - lingo *
.code
option prologue:none  ; turn it off
option epilogue:none  ;
align  16             ; 
bin2asciiL proc lpbuf:DWORD, nNumber:DWORD
mov     eax, [esp+2*4]          ; eax ->number
mov     edx, 89705F41h      ; 1e-9 * 2^61 rounded
mov ecx, eax                ;
add  eax, 1
mul     edx                 ; Divide by 1e9 by multiplying with reciprocal.
mov [esp+2*4], edi          ;
shr     edx, 29                 ; Leading decimal digit, 0...4
imul    eax, edx, 1000000000    ; Leading digit * 1e9
mov edi,  [esp+1*4]         ; edi ->buffer
sub     eax, ecx            ; Subtract (leading digit * 1e9) from argument.
lea ecx,  [edx+30h]
mov     edx, 0ABCC7712h         ; 2^28 / 1e8 * 2^30 rounded up
neg eax
mul     edx                 ; Divide reduced
mov     [edi], cl               ; Store leading digit
cmp     ecx, 31h            ; Any nonzero digit yet?
sbb     edi,   -1               ; Yes, increment ptr. No, keep old ptr.
shr     eax,  30                ; argument < 1e9 by 1e8,
lea     eax,  [eax+4*edx+1]     ; converting it into 4.28 fixed-point
mov     edx, 0FFFFFFFh
and     edx, eax ;  0FFFFFFFh       ; Fraction part

shr     eax,  28                ; Next digit
add ecx, eax
add     eax,  30h           ; Convert digit to ASCII.
cmp     ecx,  31h           ; Any nonzero digit yet?
mov     [edi], al               ; Store digit in memory
sbb     edi,   -1               ; Yes, increment ptr. No, keep old ptr.
lea     eax,  [edx*4+edx]       ; 5 * fraction, new digit EAX[31-27]
mov               edx,  7FFFFFFh        ; 5 * fraction, new fraction EDX[26-0]
and     edx,  eax           ; Fraction part
shr     eax,  27                ; Next digit
add ecx,  eax
add     eax,  30h           ; Convert digit to ASCII
mov     [edi], al               ; Store digit in memory.
lea eax,  [edx*4+edx+0C0000000h] ; 5 * fraction, new digit EAX[31-26]
cmp     ecx,  31h           ; Any nonzero digit yet?
mov     edx,  3FFFFFFh      ; Fraction part
sbb     edi,   -1               ; Yes, increment ptr. No, keep old ptr.
and               edx,  eax         ;
shr     eax,  26                ; Next digit
or  ecx, eax

mov     [edi], al               ; Store digit in memory.\
cmp     ecx,  31h           ; Any nonzero digit yet?
lea     eax,  [edx*4+edx+60000000h] ; 5 * fraction, new digit EAX[31-25]
mov     edx,  1FFFFFFh      ; Fraction part
sbb     edi,   -1               ; Yes, increment ptr. No, keep old ptr.
and     edx,  eax           ; Fraction part
shr     eax,  25                ; Next digit
or  ecx, eax    
mov     [edi], al               ; Store digit in memory.
cmp     ecx,  31h           ; Any nonzero digit yet?
lea     eax,  [edx*4+edx+30000000h] ; 5 * fraction, new digit EAX[31-24]
mov     edx,  0FFFFFFh      ; Fraction part
sbb     edi,   -1               ; Yes, increment ptr, No, keep old ptr.
and edx,  eax           ;
shr     eax,  24                ; Next digit
or  ecx, eax
mov     [edi], al               ; Store digit in memory.
cmp     ecx,  31h           ; Any nonzero digit yet?
lea     eax,  [edx*4+edx+18000000h] ; 5 * fraction, new digit EAX[31-23]
mov     edx,  7FFFFFh       ; Fraction part

sbb     edi,   -1               ; Yes, increment ptr. No, keep old ptr.
and edx,  eax           ;       
shr     eax,  23                ; Next digit
or  ecx, eax
mov     [edi], al               ; Store digit out to memory.
cmp     ecx,  31h           ; Any nonzero digit yet?
lea     eax,  [edx*4+edx+0C000000h] ; 5 * fraction, new digit EAX[31-22]
mov     edx,  3FFFFFh       ; Fraction part
sbb     edi,   -1               ; Yes, increment ptr. No, keep old ptr.
and               edx,  eax         ;
shr     eax,  22                ; Next digit
or  ecx, eax
mov     [edi], al               ; Store digit in memory.
cmp     ecx,  31h           ; Any nonzero digit yet?
lea     eax,  [edx*4+edx+6000000h]  ; 5 * fraction, new digit EAX[31-21]
mov     edx,  1FFFFFh       ; Fraction part
sbb     edi,   -1               ; Yes, increment ptr. No, keep old ptr.
and     edx,  eax           ;
shr     eax,  21                ; Next digit
mov     [edi], al               ; Store digit in memory

or  ecx, eax
cmp     ecx,  31h           ; Any nonzero digit yet?
lea     eax,  [edx*4+edx+3000000h] ; 5 * fraction, new digit EAX[31-20]
sbb     edi,   -1               ; Yes, increment ptr. No, keep old ptr.
shr     eax,   20           ; Next digit
mov     [edi],  ax          ; Store last digit and end marker in memory.
mov edi,    [esp+2*4]       ; Restore register as per calling convention
ret     2*4                 ; Pop two DWORD arguments and return
bin2asciiL  endp                ; Total 88 instructions vs 101 from AMD

option prologue:prologuedef ; turn back on the defaults
option epilogue:epiloguedef ;                      


;The character look up table. Make sure it's aligned suitably
align 16
chartab:
    dw "00","10","20","30","40","50","60","70","80","90"
    dw "01","11","21","31","41","51","61","71","81","91"
    dw "02","12","22","32","42","52","62","72","82","92"
    dw "03","13","23","33","43","53","63","73","83","93"
    dw "04","14","24","34","44","54","64","74","84","94"
    dw "05","15","25","35","45","55","65","75","85","95"
    dw "06","16","26","36","46","56","66","76","86","96"
    dw "07","17","27","37","47","57","67","77","87","97"
    dw "08","18","28","38","48","58","68","78","88","98"
    dw "09","19","29","39","49","59","69","79","89","99"   
  
option prologue:none  ; turn it off
option epilogue:none  ;

align 16 
udword proc lpbuf:DWORD, nNumber:DWORD    ;unsigned DWORD to ASCII
    push edi                   ;save registers that need to be saved
    push esi

    mov  esi, [esp+12]      ; sptr
    mov  eax, [esp+16]      ; x

    mov edi,eax                ;save a copy of the number

    mov edx, 0D1B71759h        ;=2^45\10000    13 bit extra shift
    mul edx                    ;gives 6 high digits in edx

    mov eax,68DB9h            ;=2^32\10000+1

    shr edx,13                 ;correct for multiplier offset used to give better accuracy
    jz short skiphighdigits          ;if zero then don;t need to process the top 6 digits


    mov ecx,edx                ;get a copy of high digits
    imul ecx,10000             ;scale up high digits
    sub edi,ecx                ;subtract high digits from original. EDI now = lower 4 digits


    mul edx                    ;get first 2 digits in edx
    mov ecx,100                ;load ready for later

    jnc short next1                  ;if zero, supress them by ignoring
    cmp edx,9                  ;1 digit or 2?
    ja  short ZeroSupressed          ;2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*2]     ;look up 2 digits
    mov [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc esi                    ;update pointer by 1
    jmp short ZS1               ;continue with pairs of digits to the end

next1:
    mul ecx                    ;get next 2 digits
    jnc short next2                  ;if zero, supress them by ignoring
    cmp edx,9                  ;1 digit or 2?
    ja  short ZS1a                   ;2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*2]     ;look up 2 digits
    mov [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc esi                    ;update pointer by 1
    jmp short ZS2               ;continue with pairs of digits to the end

next2:
    mul ecx                    ;get next 2 digits
    jnc short next3                  ;if zero, supress them by ignoring
    cmp edx,9                  ;1 digit or 2?
    ja  short ZS2a                   ;2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*2]     ;look up 2 digits
    mov [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc esi                    ;update pointer by 1
    jmp short ZS3               ;continue with pairs of digits to the end

next3:

skiphighdigits:
    mov eax,edi                ;get lower 4 ditigs

    mov ecx,100

    mov edx,28F5C29h          ;2^32\100 +1
    mul edx
    jnc short next4                  ;if zero, supress them by ignoring
    cmp edx,9                  ;1 digit or 2?
    ja  short ZS3a                   ;2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*2]     ;look up 2 digits
    mov [esi],dh               ;but only write the 1 we need, supress the leading zero
    inc esi                    ;update pointer by 1
    jmp short  ZS4               ;continue with pairs of digits to the end


next4:
    mul ecx                    ;this is the last pair so don;t supress a single zero
    cmp edx,9                  ;1 digit or 2?
    ja  short ZS4a                   ;2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*2]     ;look up 2 digits
    mov [esi],dh               ;but only write the 1 we need, supress the leading zero
    mov byte ptr [esi+1],0     ;zero terminate string


    jmp short  xit               ;all done


ZeroSupressed:
    mov edx,chartab[edx*2]     ;look up 2 digits
    mov [esi],dx
    add esi,2                  ;write them to answer

ZS1:
    mul ecx                    ;get next 2 digits
ZS1a:
    mov edx,chartab[edx*2]     ;look up 2 digits
    mov [esi],dx               ;write them to answer
    add esi,2

ZS2:
    mul ecx                    ;get next 2 digits
ZS2a:
    mov edx,chartab[edx*2]     ;look up 2 digits
    mov [esi],dx               ;write them to answer
    add esi,2

ZS3:
    mov eax,edi                ;get lower 4 digits
    mov edx,28F5C29h         ;2^32\100 +1
    mul edx                    ;edx= top pair
ZS3a:
    mov edx,chartab[edx*2]     ;look up 2 digits
    mov [esi],dx               ;write to answer
    add esi,2                  ;update pointer

ZS4:
    mul ecx                    ;get final 2 digits
ZS4a:
    mov edx,chartab[edx*2]     ;look them up
    mov [esi],dx               ;write to answer

    mov byte ptr [esi+2],0     ;zero terminate string


xit:
    pop esi                    ;restore used registers
    pop edi 

    ret 8
udword endp    
option prologue:prologuedef ; turn back on the defaults
option epilogue:epiloguedef ;                      






.data
align 16
szBuffer    db  30 Dup(0)  

.code
; 
start:
; 
    ;function tests

    call IdentifyCPU

tstnum= 0BBC8D09Fh

    print " ",13,10,"validity tests:",13,10
    invoke bin2ascii, addr szBuffer, tstnum
    print offset szBuffer," bin2ascii-AMD",13,10
    invoke bin2asciiL, addr szBuffer, tstnum
    print offset szBuffer," bin2ascii-lingo",13,10
    invoke udword, addr szBuffer, tstnum
    print offset szBuffer," udword",13,10

    print " ",13,10

tstnum= 186A0h

    invoke bin2ascii, addr szBuffer, tstnum
    print offset szBuffer," bin2ascii-AMD",13,10
    invoke bin2asciiL, addr szBuffer, tstnum
    print offset szBuffer," bin2ascii-lingo",13,10
    invoke udword, addr szBuffer, tstnum
    print offset szBuffer," udword",13,10

    print " ",13,10

tstnum= 0FFFFFFFEh 

    invoke bin2ascii, addr szBuffer, tstnum
    print offset szBuffer," bin2ascii-AMD",13,10
    invoke bin2asciiL, addr szBuffer, tstnum
    print offset szBuffer," bin2ascii-lingo",13,10
    invoke udword, addr szBuffer, tstnum
    print offset szBuffer," udword",13,10

    print " ",13,10

    print " ",13,10,"timing tests:",13,10

    invoke Sleep, 2000
    
    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke  bin2ascii, addr szBuffer, tstnum
    counter_end
    print ustr$(eax)," cycles, bin2ascii-AMD",13,10
    
    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke  bin2asciiL, addr szBuffer, tstnum
    counter_end
    print ustr$(eax)," cycles, bin2ascii-lingo",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke udword, addr szBuffer, tstnum
    counter_end
    print ustr$(eax)," cycles, udword",13,10

    print " ",13,10
    inkey "Press any key to exit..."
    exit
; 
end start



